<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 30.10</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container">
        <h1 class="text-center"> Form đăng nhập </h1>
        <form id="loginForm">
            <div class="group-control">
                <label>Email Address</label>
                <input type="text" id="inp-email" class="form-control" placeholder="Enter email" />
                <p style="color:gray;">We'll never share your email with anyone else</p>
            </div>
            <div class="group-control">
                <label>Password</label>
                <input type="password" id="inp-password" class="form-control" placeholder="Password" />
            </div>
            <div class="group-control" style="margin-top:5px;">
                <button type="submit" class="btn btn-primary"> Submit </button>
            </div>
        </form>
    </div>
</body>

</html>

<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        "use strict";
        var vLoginForm = document.getElementById("loginForm"); // Truy xuất phần tử thông qua id và lưu vào biến
        vLoginForm.addEventListener("submit", function (e) {
            e.preventDefault();// Chặn submit mặc định
            console.log("Submit form");

            // Bước 0: Tạo đối tượng chứa dữ liệu cần thu thập
            var vObject = {
                email: "",
                password: ""
            }
            // Bước 1: Thu thập dữ liệu
            getDataFromInput(vObject);
            console.log(vObject);
            // Bước 2: Kiểm tra dữ liệu thu thập
            var vCheck = validateData(vObject);
            console.log(vCheck);
            // Bước 3: Gọi API
            if (vCheck == true) {
                // create a request
                var vXmlHttpLogin = new XMLHttpRequest();
                processAjax(vXmlHttpLogin, vObject);
                vXmlHttpLogin.onreadystatechange =
                    function () {
                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                            var vLoginInfo = vXmlHttpLogin.responseText;                            
                            // Bước 4: Hiển thi
                            displayData(vLoginInfo);
                        }
                    }
            }
            

        })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm hiển thị dữ liệu
    // Input là dữ liệu cần hiển thị
    function displayData(paramData){
        "use strict";
        console.log(paramData);
    }
    // Hàm xử lý ajax login
    // Input là đối tượng Request và đối tượng dữ liệu
    function processAjax(paramRequest, paramObject) {
        "use strict";
        paramRequest.open("GET", gBASE_URL + "?" + paramObject.toString(), true);
        paramRequest.send();
    }
    // Hàm thu thập dữ liệu
    // Input là đối tượng chứa dữ liệu cần thu thập
    function getDataFromInput(paramObject) {
        "use strict";
        var vEmail = document.getElementById("inp-email");
        var vPassword = document.getElementById("inp-password");

        paramObject.email = vEmail.value;
        paramObject.password = vPassword.value;
    }
    // Hàm kiểm tra email hợp lệ
    // Input là email cần kiểm tra
    // Ouput là true / false
    function validateEmail(email) {
        var re = /\S+@\S+\.\S+/;
        return re.test(email);
    }
    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng cần kiểm tra
    // Output là true / false
    function validateData(paramObject) {
        "use strict";
        var vResult = true;
        var vEmail = paramObject.email.trim();
        var vPass = paramObject.password.trim();

        //Kiểm tra rỗng
        if (vEmail == "") {
            alert("Bạn chưa nhập email!");
            vResult = false;
        } else {
            if (validateEmail(vEmail) == false) {
                alert("Email không đúng định dạng!");
                vResult = false;
            }
        }

        if (vPass == "") {
            alert("Bạn chưa nhập password!");
            vResult = false;
        }

        return vResult;
    }
</script>